<?php
/**
 * translateHepler
 *
 * @version 1.1.1
 * @package translateHepler
 * @author ZyX (Micriucov Oleg)
 * @copyright (C) 2010 by ZyX (http://www.allforjoomla.ru)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project,
 * please make a reference to allforjoomla.com someplace in your code
 * and provide a link to http://www.allforjoomla.ru
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class  plgSystemTranslateHelper extends JPlugin{
	
	function __construct(&$subject, $config = array()){
		$this->isEnabled = false;
		return parent::__construct($subject, $config);
	}
	
	function onAfterInitialise(){
		$processType = $this->params->get('processtype', 'frontend');
		$app = JFactory::getApplication();
		if($processType=='frontend' && $app->getName()=='administrator') return;	
		elseif($processType=='backend' && $app->getName()=='site') return;	
		$doc = JFactory::getDocument();
		if($doc->getType()!='html') return;
		$this->isEnabled = true;
		$zTask = JRequest::getCmd('zTask','');
		if($zTask=='off'){
			$this->isEnabled = false;
			return;
		}
		include_once(JPATH_ROOT.'/plugins/system/translateHelper/language.php');
		$conf	= JFactory::getConfig();
		$locale	= $conf->get('language');
		$debug	= $conf->get('debug_lang');
		$lang = new ZLanguage($locale,$debug);
		JFactory::$language = $lang;
		
		if($zTask=='editWord'){
			$this->processEditWord();
		}
		else if($zTask=='saveWord'){
			$this->processSaveWord();
		}
	}
	
	function onAfterDispatch(){
		if(!$this->isEnabled) return;
		$doc = JFactory::getDocument();
		$doc->addStyleSheet(JURI::root().'plugins/system/translateHelper/assets/ui-lightness/jquery-ui-1.9.2.custom.css');
		$doc->addStyleSheet(JURI::root().'plugins/system/translateHelper/assets/styles.css');
		$doc->addScriptDeclaration('JURIroot="'.JURI::root().'";JURIbase="'.JURI::base().'";URL2Assets="'.JURI::root().'plugins/system/translateHelper/assets";translateHelperIcon="'.JURI::root().'plugins/system/translateHelper/assets/images/comment_edit.png"');
	}
	
	function onAfterRender(){
		if(!$this->isEnabled) return;
		$body = JResponse::getBody();
		if($body=='') return;
		$GLOBALS['translateHelperIDs'] = array();
		$this->processBodyHTML($body);
		$zLang = JFactory::getLanguage();
		$html = '';
		$html.= '<script type="text/javascript">';
		$html.= "\n".'var transHelperElems = {';
		foreach($zLang->wordsElems as $k=>$elem){
			$html.= "\n".$k.':{';
			foreach($elem as $kk=>$vv){
				$html.= "\n\t".'"'.$kk.'": "'.addslashes($vv).'",';
			}
			$html.= '},';
		}
		$html.= "\n".'};';
		$html.= "\n".'</script>';
		if(count($GLOBALS['translateHelperIDs'])){
			$GLOBALS['translateHelperIDs'] = array_unique($GLOBALS['translateHelperIDs']);
			$html.= '<div id="translateHelperInfo"><img onclick="this.parentNode.parentNode.removeChild(this.parentNode);" class="zCloseImg" src="'.JURI::root().'plugins/system/translateHelper/assets/images/icon_delete.gif" title="close" />';
			$html.= '<h3 class="hasTip" title="Texts found in scripts, titles, alt\'s and others tag parameters">Hidden texts</h3>';
			foreach($GLOBALS['translateHelperIDs'] as $id){
				$elem = $zLang->getZelement($id);
				$html.= '<div><span class="translateHelperInfoElem"><img onclick="translateHelperEditWord(this.parentNode.parentNode,'.$id.');return false;" title="Edit" src="'.JURI::root().'plugins/system/translateHelper/assets/images/comment_edit.png" /></span>'.$zLang->getZString($elem['key']).'</div>';
			}
			$html.= '</div>';
		}
		$addjQuery = $this->params->get('addjquery', 0);
		$addjQueryUI = $this->params->get('addjqueryui', 0);
		if($addjQuery) $html.= '<script src="'.JURI::root().'plugins/system/translateHelper/assets/js/jquery-1.9.1.min.js" type="text/javascript"></script>';
		if($addjQueryUI) $html.= '<script src="'.JURI::root().'plugins/system/translateHelper/assets/js/jquery-ui-1.9.2.custom.min.js" type="text/javascript"></script>';
		$html.= '<script src="'.JURI::root().'plugins/system/translateHelper/assets/js/scripts.js" type="text/javascript"></script>';
		$body = str_replace('</body>',$html.'</body>',$body);
		JResponse::setBody($body);
	}
		
	function processBodyHTML(&$body){
		$zLang = JFactory::getLanguage();
		$tags = array('option','title');
		preg_match_all('~<script[^>]+>\s+(.*?)(?=</script>)~si',$body,$regs);
		foreach((array)$regs[1] as $script){
			preg_match_all('~<translatehelperword data-id=([0-9]+)~i',$script,$sregs);
			foreach((array)$sregs[1] as $id){
				$GLOBALS['translateHelperIDs'][] = $id;
				$elem = $zLang->getZelement($id);
				$word = ($elem?$elem['word']:'');
				$body = str_replace('<translatehelperword data-id='.$id.' >',$word,$body);
			}
		}
		
		$body = preg_replace_callback('~(<('.implode('|',$tags).')[^>]*>)(.*?)(?=</('.implode('|',$tags).')>)~si',function($matches){
			preg_match_all('~((?:&(?:amp;)?lt;)|<)translatehelperword data-id=([0-9]+) ((?:&(?:amp;)?gt;)|>)~si',$matches[3],$regs);
			$zLang = JFactory::getLanguage();
			$result = $matches[1];
			$string = $matches[3];
			foreach((array)$regs[2] as $k=>$id){
				$GLOBALS['translateHelperIDs'][] = $id;
				$elem = $zLang->getZelement($id);
				$word = ($elem?$elem['word']:'');
				$string = str_replace($regs[1][$k].'translatehelperword data-id='.$id.' '.$regs[3][$k],$word,$string);
			}
			$result.= $string;
			return $result;},$body);
		
		preg_match_all('~&(:?amp;)?lt;translatehelperword data-id=([0-9]+)~si',$body,$regs);
		foreach((array)$regs[1] as $id){
			$GLOBALS['translateHelperIDs'][] = $id;
			$elem = $zLang->getZelement($id);
			$word = ($elem?$elem['word']:'');
			$body = preg_replace('~&(?:amp;)?lt;translatehelperword data-id=([0-9]+) &(?:amp;)?gt;~si',$word,$body);
		}
		$body = preg_replace_callback('~([^ ]+=\"[^\"]*)<translatehelperword data-id=([0-9]+)~si',function($matches){
			$id = $matches[2];
			$GLOBALS['translateHelperIDs'][] = $id;
			$zLang = JFactory::getLanguage();
			$elem = $zLang->getZelement($id);
			$word = ($elem?$elem['word']:'');
			return $matches[1].$word;},$body);
		
		return $IDs;
	}
	
	function processSaveWord(){
		header('Content-type: text/html; charset="utf-8"',true);
		$key = JRequest::getVar('key','');
		$key = JString::strtoupper($key);
		$ext = JRequest::getVar('ext','');
		$file = JRequest::getVar('file','');
		$newWord = JRequest::getVar('newWord','');
		if(!($key!=''&&$file!=''&&is_file($file))) $this->close('!Text or file ('.$file.') not found.');
		if(!is_writable($file)) $this->close('!File ('.$file.') is not writable.');
		$content = file_get_contents($file);
		if($this->JVersion=='1.5'){
			$replaces = array(
				'"'	=>	'"'
			);
		}
		else{
			$replaces = array(
				'"'	=>	'"_QQ_"'
			);
		}
		$word = htmlentities($newWord,ENT_NOQUOTES,'utf-8');
		$word = str_replace(array_keys($replaces),array_values($replaces),$word);
		$content = preg_replace('~'.$key.'\s?=[^\n$]+~iu',$key.'="'.$word.'"',$content);
		$result = file_put_contents($file,$content);
		if($result>0) $this->close($newWord);
		else $this->close('!Error writing to file ('.$file.').');
	}
	
	function processEditWord(){
		header('Content-type: text/html; charset="utf-8"',true);
		$zLang = JFactory::getLanguage();
		$key = JRequest::getVar('key','');
		$key = JString::strtoupper($key);
		$ext = JRequest::getVar('ext','');
		$file = JRequest::getVar('file','');
		if($ext&&$ext!='joomla'){
			$zLang->load($ext,JPATH_BASE);
		}
		$word = $zLang->getZString($key);
		if(JString::strlen($word)>50){
			$word = htmlentities($word,ENT_COMPAT,'utf-8');
			$input = '<textarea onclick="return false;" name="newWord">'.$word.'</textarea>';
		}
		else if(JString::strlen($word)>0){
			$word = htmlentities($word,ENT_COMPAT,'utf-8');
			$input = '<input onclick="return false;" type="text" class="inputtext" name="newWord" value="'.$word.'" />';
		}
		else{
			$this->close('!x!');
		}
		?>
			<img onclick="this.parentNode.parentNode.removeChild(this.parentNode);return false;" class="zCloseImg" src="<?php echo JURI::root();?>plugins/system/translateHelper/<?php echo $this->addUrl;?>assets/images/icon_cancel.gif" title="cancel" />
			<img onclick="translateHelperSave(this);return false;" class="zSaveImg" src="<?php echo JURI::root();?>plugins/system/translateHelper/<?php echo $this->addUrl;?>assets/images/icon_apply.gif" title="save" />
			<strong><?php echo $key;?></strong><span><?php echo $file;?></span>
			<form action="<?php echo JURI::base();?>">
			<input type="hidden" name="zTask" value="saveWord" />
			<input type="hidden" name="key" value="<?php echo $key;?>" />
			<input type="hidden" name="ext" value="<?php echo $ext;?>" />
			<input type="hidden" name="file" value="<?php echo $file;?>" />
			<?php echo $input;?>
			</form>
		<?php
		$this->close();
	}
	
	function close($msg=''){
		$app = JFactory::getApplication();
		if($msg!='') echo $msg;
		$app->close();
	}
	
}